
Rem *******************MONITOR ZANIKU PLOMIENIA*******************
Rem * Wersja:1.0                                                 *
Rem * Kompilator: Bascom-AVR: 1.11.7.4                           *
Rem * Autor: Karol Gnys                                          *
Rem * E-mail:calon@wp.pl                                         *
Rem * Rok: 2018                                                  *
Rem **************************************************************

'ATMEGA8: fusebit=cksel=1111 sut=10
$regfile = "m8def.dat"                                      'wybor mikroprocesora
$crystal = 8000000                                          'wybor rezonatora

Config Portc = Output                                       'portc jako wyjsciowy
Portc = &B11111111
Config Portb = Output                                       'portb jako wyjsciowy
Portb = &B11111111

Config 1wire = Portd.0                                      'ustawia portd0 jako linie 1wire

Config Timer0 = Timer , Prescale = 256 ;                    'konfiguracja timer0 dla obslugi wyswietlacza
On Timer0 Wyswietlacz                                       'skocz do obslugi wyswietlacza
Enable Interrupts
Enable Timer0
Load Timer0 , 150

Config Pinb.5 = Output                                      'wyjscie lini g wyswietlacza LED
Portb.5 = 1                                                 'stan spoczynkowy 1
Segg Alias Portb.5                                          'przypisanie nazwy segg portowi portb5

Config Pind.1 = Output                                      'wyjscie syngalizatora piezzo
Portd.1 = 1                                                 'stan spoczynkowy 1
Piezzo Alias Portd.6

Config Pind.5 = Output                                      'wyjscie diody sygnalizacyjnej zielonej
Portd.5 = 1                                                 'stan spoczynkowy 1
Dioda1 Alias Portd.5

Config Pind.6 = Output                                      'wyjscie diody sygnalizacyjnej zoltej
Portd.6 = 1                                                 'stan spoczynkowy 1
Dioda2 Alias Portd.6

Config Pind.7 = Output                                      'wyjscie diody sygnalizacyjnej czerwonej
Portd.7 = 1                                                 'stan spoczynkowy 1
Dioda3 Alias Portd.7

Config Pind.2 = Input                                       'konfiguracja lini jako wejscia
Portd.2 = 1                                                 'wlaczenie rezystora podciagajacego
W1 Alias Pind.2                                             'przypisanie nazwy W1 do wejscia portd.2

Config Pind.3 = Input                                       'konfiguracja lini jako wejscia
Portd.3 = 1                                                 'wlaczenie rezystora podciagajacego
W2 Alias Pind.3

Config Pind.4 = Input                                       'konfiguracja lini jako wejscia
Portd.4 = 1                                                 'wlaczenie rezystora podciagajacego
W3 Alias Pind.4

Dim Licznik As Bit                                          'zmienna zmiany wyswietlacza
Dim Jednostki As Integer                                    'zmienna jednosci wyswietlacza
Dim Dziesiatki As Integer                                   'zmienna dziesiatek wyswietlacza
Jednostki = 11                                              'wyswietla przypisany znak przed pierwszym czytaniem czujnika
Dziesiatki = 11                                             'wyswietla przypisany znak przed pierwszym czytaniem czujnika

Dim Odczyt(2) As Byte                                       'zmienna odczytu temperatury z DS18B20
Dim Temperatura As Integer                                  'zmienna temperaturowa
Dim Temperatura1 As Single                                  'zmienna temperaturowa1
Dim Pomoctemp As Single                                     'zmienna pomocnicza przy konwersji temperatury

Dim Temp_alarmu1 As Byte                                    'zmienna temperatury alarmu zaniku plomienia
Dim Temp_alarmu2 As Byte                                    'zmienna temperatury alarmu przekroczenia temperatury
Dim Histereza As Byte                                       'zmienna histerezy temperatury zaniku plomienia                                    '
Dim Dzwiek As Byte                                          'zmienna ilosci sygnalow dzwiekowych alarmu
Dim Dzwieklicznik As Byte                                   'zmienna licznikowa ilosci sygnalow dzwiekowych
Dim Temp_warunku As Byte                                    'zmienna w ktorej zapisana jest wartosc temperatury zaniku plomienia po dodaniu histerezy
Dim Temp_warunku2 As Byte                                   'zmienna w ktorej zapisana jest wartosc temperatury przegrzania pomniejszona o sztywna histereze
Dim Temp_zmierzona As Byte                                  'zmienna w ktorej jest zmierzona temperatura
Dim Zez2 As Bit                                             'zmienna zezwalajaca na sygnal dzwiekowy
Zez2 = 0

Dim Wyjscie As Bit
Wyjscie = 0
Dim Opcja As Byte
Opcja = 1
Dim Zez As Bit
Zez = 0
Dim Wyjscieopcja As Bit
Wyjscieopcja = 0

Readeeprom Temp_alarmu1 , 1                                 'odczytuje pamiec eeprom z ustawieniami zmiennej temp_alarmu1
Readeeprom Temp_alarmu2 , 2
Readeeprom Histereza , 3
Readeeprom Dzwiek , 4

If Temp_alarmu1 < 1 Or Temp_alarmu1 > 99 Then               'warunek spelniony kiedy w eepromie nieustalona wartosc
   Temp_alarmu1 = 35                                        ' np. przed pierwszym zapisem
End If
If Temp_alarmu2 < 1 Or Temp_alarmu2 > 99 Then
   Temp_alarmu2 = 85
End If
If Histereza < 1 Or Histereza > 20 Then
   Histereza = 10
End If
If Dzwiek < 0 Or Dzwiek > 30 Then
   Dzwiek = 5
End If



Do                                                          'PETLA GLOWNA
'**********************ODCZYT TEMPERATURY***************************
Disable Interrupts                                          'wylacz przerwania
1wreset                                                     'obsluga ukladu DS18B20
1wwrite &HCC
1wwrite &H44
Enable Interrupts                                           'wlacz przerwania
Waitms 750
Disable Interrupts
1wreset
1wwrite &HCC
1wwrite &HBE

Odczyt(1) = 1wread(2)
   Temperatura = Odczyt(2)
   Shift Temperatura , Left , 8
   Temperatura = Temperatura + Odczyt(1)
   Temperatura1 = Temperatura / 16



   Temp_zmierzona = Temperatura1

    Dziesiatki = Temperatura1 \ 10                          'ze zmiennej temperatura1 wyluskaj liczbe dziesiatek
    Pomoctemp = Dziesiatki * 10
    Jednostki = Temperatura1 - Pomoctemp                    'wykonaj operacje i wyluskaj liczbe jednostek

If Err = 1 Then                                             'jzeli nie odczytano z czujnika ds18b20 to wyswietl blad "EE"
   Dziesiatki = 10
   Jednostki = 10
End If

If Temperatura1 > 99 Then                                   'jezeli temperatura wyzsza niz 99 stopni to wyswietl blad "E2"
   Dziesiatki = 10                                          'wyswietla znak E
   Jednostki = 2
End If

If Temperatura1 < 0 Then                                    'jezeli temperatura nizsza niz 0 stopni to wyswietl blad "E1"
   Dziesiatki = 10
   Jednostki = 1
End If
Enable Interrupts
'********************************************************************

Gosub Termostat                                             'skocz do obslugi warunkow kontroli temperatury


If W1 = 0 Then                                              'jezeli nacisnieto przycisk W1 idz do wyboru menu
   Waitms 20
      If W1 = 0 Then
         Zez = 1
         Opcja = 1
         Gosub Wybormenu
      End If
End If

Loop
End


Wybormenu:
Do
If Zez = 1 Then
   Gosub Wyboropcji
End If

If W1 = 0 Then                                              'jezeli nacisnieto W1 wybor menu
   Waitms 20
      If W1 = 0 Then
         Incr Opcja
               If Opcja > 4 Then
                  Opcja = 1
               End If
         Zez = 1
      End If
End If
Loop Until Wyjscie = 1                                      'jezeli prawdziwy warunek powrot do glownej petli
Wyjscie = 0
Return


Wyboropcji:
Select Case Opcja
   Case 1:
      Gosub Opcja1                                          'ustawia temperature zaniku plomienia
   Case 2:
      Gosub Opcja2                                          'ustawia temperature przegrzania systemu grzewczego
   Case 3:
      Gosub Opcja3                                          'ustawia histereze temperatury zaniku plomienia
   Case 4:
      Gosub Opcja4                                          'ustawia ilosc sygnalow dzwiekowych alarmu
End Select
Return


Opcja1:                                                     'ustawia temperature alarmu zaniku plomienia
Do
Zez = 0                                                     'zezwala na zmiane na kolejna opcje
Reset Dioda1
Reset Dioda2
Temperatura1 = Temp_alarmu1
Gosub Cyfry
If W2 = 0 Then                                              'jezeli nacisnieto W2 to zwieksz temp_alarmu1
   Waitms 20
      If W2 = 0 Then
         Temp_alarmu1 = Temp_alarmu1 + 1
            If Temp_alarmu1 > 99 Then
               Temp_alarmu1 = 1
            End If
         Waitms 300
      End If
End If

If W3 = 0 Then                                              'jezeli nacisnieto W3 to zmniejsz temp_alarmu1
   Waitms 20
      If W3 = 0 Then
         Temp_alarmu1 = Temp_alarmu1 - 1
            If Temp_alarmu1 < 1 Then
               Temp_alarmu1 = 99
            End If
         Waitms 300
      End If
End If

If W1 = 0 Then                                              'jzeli nacisnieto W1 to wyjdz z ustawien
   Waitms 500
      If W1 = 0 Then
         Wyjscieopcja = 1
      End If
End If
Loop Until Wyjscieopcja = 1
     Set Dioda1
     Set Dioda2
     Writeeeprom Temp_alarmu1 , 1                           'zapisuje do eeproma zmienna temp_alarmu1
Wyjscieopcja = 0
Return


Opcja2:                                                     'ustawia temperature przegrzania systemu
Do
Zez = 0
Reset Dioda1
Reset Dioda3
Temperatura1 = Temp_alarmu2
Gosub Cyfry
If W2 = 0 Then
   Waitms 20
      If W2 = 0 Then
         Temp_alarmu2 = Temp_alarmu2 + 1
            If Temp_alarmu2 > 99 Then
               Temp_alarmu2 = 1
            End If
         Waitms 300
      End If
End If

If W3 = 0 Then
   Waitms 20
      If W3 = 0 Then
         Temp_alarmu2 = Temp_alarmu2 - 1
            If Temp_alarmu2 < 1 Then
               Temp_alarmu2 = 99
            End If
         Waitms 300
      End If
End If

If W1 = 0 Then
   Waitms 500
     If W1 = 0 Then
        Wyjscieopcja = 1
      End If
End If
Loop Until Wyjscieopcja = 1
     Set Dioda1
     Set Dioda3
     Writeeeprom Temp_alarmu2 , 2
Wyjscieopcja = 0
Return


Opcja3:                                                     'ustawia histereze zalaczenia sygnalizacji obecnosci plomienia
Do
Zez = 0
Reset Dioda1
Reset Dioda2
Reset Dioda3
Temperatura1 = Histereza
Gosub Cyfry
If W2 = 0 Then
   Waitms 20
      If W2 = 0 Then
         Histereza = Histereza + 1
            If Histereza > 20 Then
               Histereza = 1
            End If
         Waitms 300
      End If
End If

If W3 = 0 Then
   Waitms 20
      If W3 = 0 Then
         Histereza = Histereza - 1
            If Histereza < 1 Then
               Histereza = 20
            End If
         Waitms 300
      End If
End If

If W1 = 0 Then
   Waitms 500
      If W1 = 0 Then
         Wyjscieopcja = 1
      End If
End If
Loop Until Wyjscieopcja = 1
     Set Dioda1
     Set Dioda2
     Set Dioda3
     Writeeeprom Histereza , 3
Wyjscieopcja = 0
Return


Opcja4:                                                     'ustawia ilosc sygnalow dzwiekowych
Do
Zez = 0
Reset Dioda1
Temperatura1 = Dzwiek
Gosub Cyfry
If W2 = 0 Then
   Waitms 20
      If W2 = 0 Then
         Dzwiek = Dzwiek + 1
            If Dzwiek > 60 Then
               Dzwiek = 0
            End If
         Waitms 300
      End If
End If

If W3 = 0 Then
   Waitms 20
      If W3 = 0 Then
         Dzwiek = Dzwiek - 1
            If Dzwiek = -1 Then
               Dzwiek = 60
            End If
         Waitms 300
      End If
End If

If W1 = 0 Then
   Waitms 500
      If W1 = 0 Then
         Wyjscieopcja = 1
      End If
End If
Loop Until Wyjscieopcja = 1
     Set Dioda1
     Writeeeprom Dzwiek , 4
Wyjscieopcja = 0
Wyjscie = 1
Return


Termostat:                                                  'warunki obslugi kontroli plomienia
Temp_warunku = Temp_alarmu1 + Histereza                     'zmienna w ktorej zapisana jest wartosc temperatury zaniku plomienia po dodaniu histerezy
If Zez2 = 1 Then
   If Temp_zmierzona <= Temp_alarmu1 Then                   'jezeli temperatura nizsza niz temp.zaniku to wlacz sygnalizacje
      Zez2 = 0
      Set Dioda2
      Gosub Alarm1
   End If
End If

If Temp_zmierzona >= Temp_warunku Then                      'wlacza diode2 obecnosci plomienia
   Reset Dioda2
   Zez2 = 1
End If

Temp_warunku2 = Temp_alarmu2 - 1
If Temp_zmierzona >= Temp_alarmu2 Then                      'jezeli przekroczono temp_alarmu2 -przegrzania systemu- wlacz sygnalizacje
   Reset Dioda3
   Gosub Alarm2
End If

If Temp_zmierzona <= Temp_warunku2 Then                     'wylacz sygnazlizacje przegrzania systemu z jedno stopniowa histereza
   Set Dioda3
End If
Return


Alarm1:                                                     'sygnalizacja akustyczna zaniku plomienia
Dzwieklicznik = 0
If Dzwiek > 0 Then                                          'jezeli dzwiek=0 to brak dzwieku
   For Dzwieklicznik = 1 To Dzwiek
       Sound Portd.1 , 400 , 400                            'dzwiek zaniku plomienia
       Sound Portd.1 , 800 , 500
   Next
End If
Return

Alarm2:                                                     'sygnalizacja akustyczna przegrzania pieca
      Sound Portd.1 , 300 , 100                             'dzwiek przegrzania pieca
      Sound Portd.1 , 400 , 250
Return


Cyfry:
Dziesiatki = Temperatura1 \ 10                              'ze zmiennej temperatura1 wyluskaj liczbe dziesiatek
    Pomoctemp = Dziesiatki * 10
    Jednostki = Temperatura1 - Pomoctemp                    'wyluskaj liczbe jednostek
Return


Wyswietlacz:                                                'procedura obslugi wyswietlacza 2LED
Load Timer0 , 150
If Licznik = 0 Then
   Portc = Lookup(jednostki , Kod7seg)                      'wyswietla jednostki na wyswietlaczu LED
   Set Portb.3                                              'wylacz i wlacza odpowiedni wyswietlacz
   Reset Portb.4

Select Case Jednostki                                       'wlacza lub wylacza segment g wyswietlacza LED
      Case 0:
         Set Segg
      Case 1:
         Set Segg
      Case 2:
         Reset Segg
      Case 3:
         Reset Segg
      Case 4:
         Reset Segg
      Case 5:
         Reset Segg
      Case 6:
         Reset Segg
      Case 7:
         Set Segg
      Case 8:
         Reset Segg
      Case 9:
         Reset Segg
      Case 10:
         Reset Segg
      Case 11:
         Reset Segg
End Select
      Licznik = 1

Else

Portc = Lookup(dziesiatki , Kod7seg)                        'wyswietla dziesiatki na wyswietlaczu LED
      Set Portb.4
      Reset Portb.3
Select Case Dziesiatki
      Case 0:
         Set Segg
      Case 1:
         Set Segg
      Case 2:
         Reset Segg
      Case 3:
         Reset Segg
      Case 4:
         Reset Segg
      Case 5:
         Reset Segg
      Case 6:
         Reset Segg
      Case 7:
         Set Segg
      Case 8:
         Reset Segg
      Case 9:
         Reset Segg
      Case 10:
         Reset Segg
      Case 11:
         Reset Segg
End Select
Licznik = 0
End If
Return

Kod7seg:                                                    'tabela cyfr dla wyswietlacza LED
Data 192 , 249 , 164 , 176 , 153 , 146 , 130 , 248 , 128 , 144 , 6 , 255
Rem    0     1     2     3     4     5     6     7     8     9    C